<?php

class Logger {

    private static $instance;
    private $filename;
    private $level;

	const LIB = 0;
    const DEBUG = 1;
    const INFO = 2;
    const WARN = 3;
    const ERROR = 4;

    private function __construct($level=self::DEBUG, $filename='debug.log') {
        // NOTE: Default is DEBUG, to log all 'user level' code.
		// Set Level to LIB to Log LIBRARY code output.
        $this -> level = $level;
        $this -> filename = $filename;
    }

    public static function instance() {
        if (!isset(self::$instance)) {
            self::$instance = new Logger();
        }
        return self::$instance;
    }

    public function getLevel() {
        return $this -> level;
    }

    public function setLevel($level) {
        $this -> level = $level;
    }

    public function lib($message) {
        return $this -> log(self::LIB, $message);
    }
	
    public function debug($message) {
        return $this -> log(self::DEBUG, $message);
    }

    public function info($message) {
        return $this -> log(self::INFO, $message);
    }

    public function warn($message) {
        return $this -> log(self::WARN, $message);
    }

    public function error($message) {
        return $this -> log(self::ERROR, $message);
    }

    private function log($level, $message) {
        if ($level >= $this -> level) {
            $names = array('LIB', 'DEBUG', 'INFO', 'WARN', 'ERROR');
            $timestamp = date('Y-m-d H:i:s', time());
            // open the file
            $fd = fopen($this -> filename, 'a');

            // write the message
            fprintf($fd, "%s %s %s\r\n", $timestamp, $names[$level], $message);

            // close the file
            fclose($fd);
        }
    }
}